/* NIGHTFALL OpenGL Interface                                              */
/* Copyright (C) 2001 Markus Kuster                                        */
/*                                                                         */
/*  This program is free software; you can redistribute it                 */
/*  and/or modify                                                          */
/*  it under the terms of the GNU General Public License as                */
/*  published by                                                           */
/*  the Free Software Foundation; either version 2 of the License, or      */
/*  (at your option) any later version.                                    */
/*                                                                         */
/*  This program is distributed in the hope that it will be useful,        */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*  GNU General Public License for more details.                           */
/*                                                                         */
/*  You should have received a copy of the GNU General Public License      */
/*  along with this program; if not, write to the Free Software            */
/*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              */

#ifdef _WITH_OPENGL
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <gtkgl/gtkglarea.h>
#include <GL/gl.h>
#include <GL/glut.h>

/* OpenGL preferences window opened        */
extern int GLPrefWinOpened;
extern int GLPrefWinHidden;

/************************************************
  
   Global OpenGL widgets

*************************************************/


/* ------------------------  toggle buttons  ---------------------- */

extern GtkWidget   *ButtonWire;          /* toggle wire frame on/off*/
extern GtkWidget   *ButtonPoints;        /* toggle points on/off    */
extern GtkWidget   *ButtonOpaque;        /* toggle opaque on/off    */
extern GtkWidget   *ButtonTexture;       /* toggle texture on/off   */
extern GtkWidget   *ButtonPrimTxt;       /* toggle prim. text on/off*/
extern GtkWidget   *ButtonSecTxt;        /* toggle sec. text on/off */
extern GtkWidget   *ButtonDiskTxt;       /* toggle disk text on/off */
extern GtkWidget   *ButtonLabels;        /* toggle labels on/off    */
extern GtkWidget   *ButtonAxes;          /* toggle axes on/off      */
extern GtkWidget   *ButtonCancel;        /* Cancel button           */
extern GtkWidget   *ButtonApply;         /* Apply button            */
extern GtkWidget   *ButtonOk;            /* Ok button               */

/* ----------------  entry fields (texture)  ---------------------- */

extern GtkWidget   *PrimTxtLabel;        /* prim. texture label     */
extern GtkWidget   *SecTxtLabel;         /* sec. texture label      */
extern GtkWidget   *DiskTxtLabel;        /* disk texture label      */

/************************************************
  
   PROTOTYPES

*************************************************/

/* --- main window ---------------------------- */
void GLPrefs(void);

/* --- event handling ------------------------- */
void GLDeletePrefs (GtkWidget *widget, gpointer *data);
void GLAxesEvent (GtkWidget *widget, gpointer *data);
void GLFilledEvent (GtkWidget *widget, gpointer *data);
void GLPrimTextureEvent (GtkWidget *widget, gpointer *data);
void GLSecTextureEvent (GtkWidget *widget, gpointer *data);
void GLDiskTextureEvent (GtkWidget *widget, gpointer *data);

#endif






