#ifndef P_EXECUTE_H
#define P_EXECUTE_H

/* Returns 1 if config file "parallel.cfg" exists, 0 otherwise
 */
int use_parallel();

/* set nonzero for verbose 
 */
void verbose_parallel(int is_verbose);

/* Free anything related to this.
 */
void kill_this(int cookie);

/* return: 1 on finished, 0 on running, -1 on error
 */
int check_result(int cookie, double * retval);

/* cleanup everything
 */
void execute_cleanup();

/* caller must store cookie to associate with result
 */
int execute(char * command, int * cookie, int tries);

/* re-execute on error 
 */
int re_execute(int cookie, int tries);

/* purge cookie after failed re-execute
 */
void purge_cookie(int cookie);

/* Cleanup function for atexit() */
void zero_all_hosts();


#endif
